Description

Currently, Redmine creates two thumbnail images for each image. This is because the img tag for displaying thumbnails requires two

resolution images (see below). For example, if Setting.thumbnails_size is set to 100, a 100px thumbnail and a higher resolution

version of a 200px thumbnail will be created.

<img srcset="/attachments/thumbnail/24/200 2x" style="max-width: 100px; max-height: 100px;" loadin

g="lazy" src="/attachments/thumbnail/24" />

 However, a low-resolution 100px thumbnail is unnecessary for the following reasons:

Nowadays, almost all web browsers support srcset attribute. The low-resolution thumbnail specified by src attribute is

unnecessary for those browsers to render a page

Even if a user's browser does not support srcset attribute, low-resolution thumbnails are still unnecessary. Since max-width and

max-hight are specified, thumbnails are displayed at the expected size even with high-resolution images

The attached patch changes ApplicationHelper#thumbnail_tag to only use a high-resolution thumbnail only.

<img srcset="/attachments/thumbnail/24/200 2x" style="max-width: 100px; max-height: 100px;" loadin

g="lazy" src="/attachments/thumbnail/24/200" />

 This reduces the number of thumbnails created when a user accesses an issue or wiki page by half. This means that halves the

number of calls of an expensive Redmine::Thumbnail.generate method.

Associated revisions

Revision 21784 - 2022-08-28 08:35 - Go MAEDA

Don't create two thumbnails of different resolutions for a single image (#37597).

Patch by Go MAEDA.

History

#1 - 2022-08-23 12:03 - Go MAEDA

Sorry I must have been mistaken. Browsers that support srcset never GET the image specified by src attribute. But the patch is still useful because it

ensures that two different sizes of thumbnails are never created.

#2 - 2022-08-24 11:52 - Go MAEDA

- Subject changed from Halves the load of thumbnails creation to Don't create two thumbnails of different resolutions for a single image

#3 - 2022-08-25 16:48 - Go MAEDA

- Target version set to 5.1.0

Setting the target version to 5.1.0.

#4 - 2022-08-27 08:01 - Go MAEDA

- Category changed from Performance to Attachments

#5 - 2022-08-28 09:14 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA
Committed the patch.

Files

generate-hires-thumbnails-only.patch 1.36 KB 2022-08-23 Go MAEDA
